/* voc 2.1.0 [2017/07/21] for mingw ILP32 on windows xtspaF */

#ifndef Platform__h
#define Platform__h

#include "SYSTEM.h"

typedef
	struct Platform_FileIdentity {
		INT64 _prvt0;
		char _prvt1[32];
	} Platform_FileIdentity;

typedef
	void (*Platform_SignalHandler)(INT32);


import BOOLEAN Platform_LittleEndian;
import INT32 Platform_PID;
import CHAR Platform_CWD[4096];
import INT32 Platform_SeekSet, Platform_SeekCur, Platform_SeekEnd;
import INT32 Platform_StdIn, Platform_StdOut, Platform_StdErr;
import CHAR Platform_NL[3];

import ADDRESS *Platform_FileIdentity__typ;

import BOOLEAN Platform_Absent (INT32 e);
import INT32 Platform_Chdir (CHAR *n, ADDRESS n__len);
import INT32 Platform_Close (INT32 h);
import BOOLEAN Platform_ConnectionFailed (INT32 e);
import void Platform_Delay (INT64 ms);
import BOOLEAN Platform_DifferentFilesystems (INT32 e);
import INT32 Platform_Error (void);
import void Platform_Exit (INT64 code);
import void Platform_GetClock (INT64 *t, INT64 *d);
import void Platform_GetEnv (CHAR *var, ADDRESS var__len, CHAR *val, ADDRESS val__len);
import void Platform_GetTimeOfDay (INT64 *sec, INT64 *usec);
import INT32 Platform_Identify (INT32 h, Platform_FileIdentity *identity, ADDRESS *identity__typ);
import INT32 Platform_IdentifyByName (CHAR *n, ADDRESS n__len, Platform_FileIdentity *identity, ADDRESS *identity__typ);
import BOOLEAN Platform_Inaccessible (INT32 e);
import BOOLEAN Platform_Interrupted (INT32 e);
import BOOLEAN Platform_IsConsole (INT32 h);
import void Platform_MTimeAsClock (Platform_FileIdentity i, INT64 *t, INT64 *d);
import INT32 Platform_New (CHAR *n, ADDRESS n__len, INT32 *h);
import BOOLEAN Platform_NoSuchDirectory (INT32 e);
import INT32 Platform_OSAllocate (INT32 size);
import void Platform_OSFree (INT32 address);
import INT32 Platform_OldRO (CHAR *n, ADDRESS n__len, INT32 *h);
import INT32 Platform_OldRW (CHAR *n, ADDRESS n__len, INT32 *h);
import INT32 Platform_Read (INT32 h, INT32 p, INT64 l, INT64 *n);
import INT32 Platform_ReadBuf (INT32 h, SYSTEM_BYTE *b, ADDRESS b__len, INT64 *n);
import INT32 Platform_Rename (CHAR *o, ADDRESS o__len, CHAR *n, ADDRESS n__len);
import BOOLEAN Platform_SameFile (Platform_FileIdentity i1, Platform_FileIdentity i2);
import BOOLEAN Platform_SameFileTime (Platform_FileIdentity i1, Platform_FileIdentity i2);
import INT32 Platform_Seek (INT32 h, INT64 o, INT32 r);
import void Platform_SetBadInstructionHandler (Platform_SignalHandler handler);
import void Platform_SetMTime (Platform_FileIdentity *target, ADDRESS *target__typ, Platform_FileIdentity source);
import INT32 Platform_Size (INT32 h, INT64 *l);
import INT32 Platform_Sync (INT32 h);
import INT32 Platform_System (CHAR *cmd, ADDRESS cmd__len);
import INT64 Platform_Time (void);
import BOOLEAN Platform_TimedOut (INT32 e);
import BOOLEAN Platform_TooManyFiles (INT32 e);
import INT32 Platform_Truncate (INT32 h, INT64 limit);
import INT32 Platform_Unlink (CHAR *n, ADDRESS n__len);
import INT32 Platform_Write (INT32 h, INT32 p, INT64 l);
import BOOLEAN Platform_getEnv (CHAR *var, ADDRESS var__len, CHAR *val, ADDRESS val__len);
import void *Platform__init(void);

#define Platform_SetInterruptHandler(h)	SystemSetInterruptHandler((ADDRESS)h)
#define Platform_SetQuitHandler(h)	SystemSetQuitHandler((ADDRESS)h)

#endif // Platform
